/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/
   
module  alarm_clock(
    clk       ,
    rst_n     ,
    key       ,
    segment   ,
    seg_sel   ,
    beep
);
input                   clk             ;
input                   rst_n           ;
input   [2:0 ]          key             ;
output  [7:0 ]          segment         ;
output  [7:0 ]          seg_sel         ;
output                  beep            ;

wire    [7:0 ]          segment         ;
wire    [7:0 ]          seg_sel         ;
wire                    beep            ;
wire    [3:0 ]          xs_sec_low      ;
wire    [3:0 ]          xs_sec_high     ;
wire    [3:0 ]          xs_min_low      ;
wire    [3:0 ]          xs_min_high     ;
wire    [3:0 ]          sec_low         ;
wire    [3:0 ]          sec_high        ;
wire    [3:0 ]          min_low         ;
wire    [3:0 ]          min_high        ;
wire    [25:0]          counter         ;
wire    [3:0 ]          key_vld         ;
wire                    flag_set        ;

key_module u0(
             .clk         (clk         ),
             .rst_n       (rst_n       ),
             .key_in      (key         ),
             .key_vld     (key_vld     )
             );
time_data u1(
             .clk         (clk         ), 
             .rst_n       (rst_n       ), 
             .key_vld     (key_vld     ), 
             .flag_set    (flag_set    ), 
             .end_counter (end_counter ),
             .sec_low     (sec_low     ),
             .sec_high    (sec_high    ),
             .min_low     (min_low     ),
             .min_high    (min_high    ),
             .xs_sec_low  (xs_sec_low  ), 
             .xs_sec_high (xs_sec_high ), 
             .xs_min_low  (xs_min_low  ), 
             .xs_min_high (xs_min_high ) 
             );
beep u2(
             .clk         (clk         ), 
             .rst_n       (rst_n       ), 
             .flag_set    (flag_set    ), 
             .end_counter (end_counter ), 
             .beep        (beep        ),
             .sec_low     (sec_low     ),
             .sec_high    (sec_high    ),
             .min_low     (min_low     ),
             .min_high    (min_high    ),
             .xs_sec_low  (xs_sec_low  ),
             .xs_sec_high (xs_sec_high ),
             .xs_min_low  (xs_min_low  ),
             .xs_min_high (xs_min_high ) 
             );
seg_disp u3( 
             .clk         (clk         ), 
             .rst_n       (rst_n       ), 
             .segment_data({xs_min_high,xs_min_low,xs_sec_high,xs_sec_low,min_high,min_low,sec_high,sec_low}), 
             .segment     (segment     ), 
             .seg_sel     (seg_sel     )  
);


endmodule





