/************************************************************************************
The code is designed and produced by MDY Science and Education Co., Ltd, which has the entire ownership. It is only for personal learning, which cannot be used for commercial or profit-making purposes without permission.

    MDY's Mission: Develop Chip Talents and Realize National Chip Dream.

    We sincerely hope that our students can learn the real IC / FPGA code through our standard and rigorous code.

    For more FPGA learning materials, please visit the Forum: http://fpgabbs.com/ and official website: http://www.mdy-edu.com/index.html 

    *************************************************************************************/

module beep(
    clk        ,
    rst_n      ,
    flag_set  ,
    end_counter,
    xs_sec_low ,
    xs_sec_high,
    xs_min_low ,
    xs_min_high,
    sec_low    ,
    sec_high   ,
    min_low    ,
    min_high   ,
    beep     
);
input             clk          ;
input             rst_n        ;
input             flag_set    ;
input             end_counter  ;
input    [3:0 ]   xs_sec_low   ;
input    [3:0 ]   xs_sec_high  ;
input    [3:0 ]   xs_min_low   ;
input    [3:0 ]   xs_min_high  ;
input    [3:0 ]   sec_low      ;
input    [3:0 ]   sec_high     ;
input    [3:0 ]   min_low      ;
input    [3:0 ]   min_high     ;
output            beep         ;

reg      [2:0 ]   miao         ;
reg               flag_add     ;
reg               init         ;
reg               beep         ;
wire              add_miao     ;
wire              end_miao     ;
always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_add <= 0;
    end
    else if(sec_low==xs_sec_low&&sec_high==xs_sec_high&&min_low==xs_min_low&&min_high==xs_min_high&&init&&flag_set==0)begin
        flag_add <= 1;
    end
    else if(end_miao)begin
        flag_add <= 0;
    end
end


always@(*)begin
    if(!sec_low&&!sec_high&&!min_low&&!min_high)begin
        init=0;
    end
    else begin
        init=1;
    end
end


always @(posedge clk or negedge rst_n) begin 
    if (rst_n==0) begin
        miao <= 0; 
    end
    else if(add_miao) begin
        if(end_miao)
            miao <= 0; 
        else
            miao <= miao+1 ;
   end
end
assign add_miao = flag_add && end_counter;
assign end_miao = add_miao  && miao == 5-1 ;


always@(posedge clk or negedge rst_n)begin
     if(rst_n==1'b0)begin
        beep<=1'b1;
    end
    else if(flag_add)begin
        beep<=1'b0;
    end
    else
        beep<=1'b1;
end


endmodule
